%define section free
%define base_name turbine-jcs
%define jcs_version 1.0

Summary:        Java Caching System
Name:           jakarta-%{base_name}
Version:        %{jcs_version}
Release:        0.20031216dev.3jpp
Epoch:          0
License:        Apache Software License
URL:            http://jakarta.apache.org/turbine/jcs/
Group:          Development/Libraries
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        http://cvs.apache.org/dist/jakarta/turbine/nightly/jakarta-turbine-jcs/jakarta-turbine-jcs-dev-20031216.tar.gz
Source1:        jakarta-turbine-jcs-dev-docs-20031216.tar.gz
Source2:        jakarta-turbine-jcs-build.xml
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.5
BuildRequires:  jakarta-commons-configuration
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-lang
BuildRequires:  concurrent
BuildRequires:  hsqldb
BuildRequires:  log4j
BuildRequires:  servletapi3
BuildRequires:  javagroups
BuildRequires:  jisp2
BuildRequires:  velocity
BuildRequires:  junit
BuildRequires:  xmlrpc
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:  /usr/sbin/update-alternatives
Requires:  jakarta-commons-configuration
Requires:  jakarta-commons-logging
Requires:  jakarta-commons-lang
Requires:  concurrent
Requires:  hsqldb
Requires:  log4j
Requires:  servletapi3
Requires:  javagroups
Requires:  jisp2
Requires:  velocity
Requires:  xmlrpc
Requires:  xerces-j2
Requires:  xml-commons-apis
Provides:  hibernate_in_process_cache
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
JCS is a distributed caching system written in java 
for server-side java applications. It is intended to 
speed up dynamic web applications by providing a means 
to manage cached data of various dynamic natures. 
Like any caching system, the JCS is most useful for 
high read, low put applications. Dynamic content and 
reporting systems can benefit most. 
However, any site that repeatedly constructs pages, 
dropdowns, or common search results form a database 
that is updated at intervals (rather than across 
categories continuously) can improve performance and 
scalability by implementing caching. Latency times drop 
sharply and bottlenecks move away from the database in 
an effectively cached system. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package manual
Summary:        Docs for %{name}
Group:          Development/Documentation

%description manual
Docs for %{name}.

%prep
%setup -q -n %{name}-dev-20031216
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
gzip -dc %{SOURCE1} | tar -xf -
cp %{SOURCE2} build.xml

%build
export CLASSPATH=$(build-classpath \
commons-configuration \
commons-logging \
commons-lang \
concurrent \
hsqldb \
log4j \
servletapi3 \
javagroups \
jisp2  \
velocity \
xmlrpc-1.2 \
xerces-j2 \
xml-commons-apis \
junit)
CLASSPATH=src/test-conf:target/classes:target/test-classes:$CLASSPATH
ant -Dbuild.sysclasspath=only dist

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p target/jcs-1.0-dev.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && ln -s %{name}-%{version}.jar %{base_name}-%{version}.jar)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# hibernate_in_process_cache ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/hibernate_in_process_cache.jar

%clean
rm -rf $RPM_BUILD_ROOT

%post
update-alternatives --install %{_javadir}/hibernate_in_process_cache.jar \
  hibernate_in_process_cache %{_javadir}/%{name}.jar 10

%preun
{
  [ $1 -eq 0 ] || exit 0
  update-alternatives --remove hibernate_in_process_cache %{_javadir}/%{name}.jar
} >/dev/null 2>&1 || :


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{base_name}.jar
%{_javadir}/%{base_name}-%{version}.jar
%ghost %{_javadir}/hibernate_in_process_cache.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%changelog
* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.3jpp
- Relax some versioned dependencies
- provide hibernate_in_process_cache and update-alternatives, prio 10

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.2jpp
- set dependency to jisp2, instead of jisp

* Wed Jan 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.20031216dev.1jpp
- First JPackage release

